#
#  GruopCGI2000
#    arraydb.pl ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
my $my_name = 'arraydb.pl';  ## This script name
my $db_dir = './data';
my $CGI = 1;  ## for CGI use

package ArrayDB;

sub Retrieve {
	my ($pkg, $db_name) = @_;
	my $db_file = "$db_dir/$db_name.adb";

	open (DB, "$db_file") || &Error::error ("$my_name\:\:Retrieve","Can't open $db_file", "$!");
	my @data_line = <DB>;
	close (DB);
	unshift (@data_line, "$db_name");
	my $ra_data_line = \@data_line;

	if (ref ($ra_data_line)) { bless ($ra_data_line, 'ArrayDB'); }

	return $ra_data_line;
}
sub GetArray {
	my ($adb, $array_name) = @_;

	## separating data stream from DB. ----
	my $flag = 0;
	my @array_line;
	foreach (@{$adb}) {
		if (/^[# \r\n]/) { next; }
		if (/^$array_name\W/) { $flag = 1; }
		if ($flag) { push (@array_line, $_); }
		if (/}/ && $flag) { last; }
	}
#	print "@array_line\n";  ## debug print ! 

	## constracting data stracture. ----
	my $ra_result;
	my $r = 0;
	foreach (@array_line) {
		if (/^$array_name\W/) { next; }
		if (/{/) { next; }
		if (/}/) { last; }

		chomp;
		$_ =~ s/^\t//;
		my @col = split (/,/);
		$ra_result->[$r] = \@col;

		$r ++;
	}
	if (ref ($ra_result)) { bless ($ra_result, 'ArrayDB'); }
	return $ra_result;
}
sub Store {
	my ($adb) = @_;
	my $db_name = shift (@{$adb});
	my $db_file = "$db_dir/$db_name.adb";

	open (DB, ">$db_file") || &Error::error ("$my_name\:\:Store","Can't open $db_file", "$!");
	flock (DB, 2);
	print DB @{$adb};
	close (DB);
}
sub SetArray {
	my ($adb, $array_name, $ra_array) = @_;
	if (!$ra_array) { return 0; }

	## make array byte stream Dump ----
	my @line = @{$ra_array};
	foreach (@line) {
		$_ = join (',', @{$_});
		$_ = "\t$_\n";
	}
	unshift (@line, "$array_name {\n");
	push (@line, "}\n");

	## seek byte stream from DB. ----
	my $flag = 0;
	my $r = 0;
	my ($r_s, $r_e) = (0, 0);
	foreach (@{$adb}) {
		$r ++;
		if (/^[# \r\n]/) { next; }
		if (/^$array_name\W/) { $flag = 1; $r_s = $r; next; }
		if (/}/ && $flag) { $r_e = $r; last; }
	}
	## set byte stream dump. ----
	if ($flag) { splice (@{$adb}, $r_s - 1, $r_e - $r_s + 1, @line); }
	else { push (@{$adb}, @line); }

#	print "@{$adb}";  ## debug print !
}
sub Dump {
	my ($ra_array, $array_name) = @_;

	## print array byte stream Dump ----
	print "$array_name {\n";

	my @line = @{$ra_array};
	foreach (@line) {
		$_ = join (",", @{$_});
		print "\t$_\n";
	}

	print "}\n";
}
sub RemoveArray {
	my ($adb, $array_name) = @_;

	## seek data stream from DB. ----
	my $flag = 0;
	my $r = 0;
	my ($r_s, $r_e) = (0, 0);
	foreach (@{$adb}) {
		$r ++;
		if (/^[# \r\n]/) { next; }
		if (/^$array_name\W/) { $flag = 1; $r_s = $r; next; }
		if (/}/ && $flag) { $r_e = $r; last; }
	}
	## set data stream dump. ----
	if ($flag) { splice (@{$adb}, $r_s - 1, $r_e - $r_s + 1); }
	else { return 0; }

#	print "@{$adb}";  ## debug print !
}
sub Sort {
	my ($ra_array, $col, $type, $sort) = @_;
	## sorted column is $col.
	## assume data type as $type. 'CHARACTER' or 'NUMBER'.
	## $sort at 'UP' or 'DOWN'.

	if (!$col) { $col = 0; }
	if (!$type) { $type = 'CHARACTER'; }
	if (!$sort) { $sort = 'UP'; }

	my %sort_row;
	my $r = 0;
	foreach (@{$ra_array}) {
		$sort_row{"$ra_array->[$r]->[$col]:$r"} = $r;
		$r ++;
	}
	my @sort_keys = keys (%sort_row);
	if ($type eq 'CHARACTER' && $sort eq 'UP') { @sort_keys = sort { $a cmp $b } @sort_keys; }
	if ($type eq 'CHARACTER' && $sort eq 'DOWN') { @sort_keys = sort { $b cmp $a } @sort_keys; }
	if ($type eq 'NUMBER' && $sort eq 'UP') { @sort_keys = sort { $a <=> $b } @sort_keys; }
	if ($type eq 'NUMBER' && $sort eq 'DOWN') { @sort_keys = sort { $b <=> $a } @sort_keys; }

	my @row_order;
	foreach (@sort_keys) {
		push (@row_order, $sort_row{"$_"});
	}
	my @sorted_array =  @{$ra_array}[@row_order];

	my $ra_sorted_array = \@sorted_array;
	if (ref ($ra_sorted_array)) { bless ($ra_sorted_array, 'ArrayDB'); }

	return ($ra_sorted_array, \@row_order);
}
sub Search {
	my ($ra_array, $value, $col) = @_;
	## if $col exists, searching the $col.

	my @row_order;
	my @hit_col;
	my $r = 0;
	foreach (@{$ra_array}) {
		my @col = @{$_};
		my $c = 0;
		foreach (@col) {
			if ($_ =~ /$value/) {
				push (@row_order, $r);
				push (@hit_col, $c);
				last;
			}
			$c ++;
		}
		$r ++;
	}

	my @result =  @{$ra_array}[@row_order];

	my $ra_result = \@result;
	if (ref ($ra_result)) { bless ($ra_result, 'ArrayDB'); }

	return ($ra_result, \@row_order, \@hit_col);
}

package Error;
##  error ------
sub error {
	my @msg = @_;

	if (!@msg) { @msg = ("Error: script encountered fatal error\n"); }

	if ($CGI) {
	        print "Content-type: text/html\n\n";
	        print "<html>\n<body bgcolor=#FFFFFF>\n";
	        print "<center><hr width=75%><h3>ERROR !</h3>\n";
		foreach (@msg) {
		        print "<P><font color=#DD0000><B>$_</B></font>\n";
		}
	 	print "<P><hr width=75%></center>\n";
	} else {
		print "auth-lib.pl: @msg";
	}
        exit;
}

1; #return true 
