#!/usr/bin/perl -w
#
#  GruopCGI2000
#    auth-lib.pl ver.1.30.00.0320
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
$my_name = 'auth-lib.pl';  ## This script name

require 'template.pl';
require 'hashdb.pl';

$denied_file = './admin/login_denied.htm';
$system_db_name = 'sys';
$user_db_name = 'user';
$group_db_name = 'group';
$session_db_name = 'session';

## authentication routines ------
sub Login {
	my ($uid, $pass) = @_;

	if (!&CheckUserPasswd ($uid, $pass)) {
		if($imode) {
			&show_imode_login_denied;
		}else{
			print "Content-type: text/html\n\n";
			&parse_template("$denied_file", *STDOUT);
		}

		return 0  ## password check is failer !
	}

	my $sid = &CreateSessionId ();
	my $ip = $ENV{'REMOTE_HOST'};

	## session db --
	my $session_db = &HashDB::Retrieve ("$session_db_name");
	my $rh_SESSION = $session_db->GetHash ('SESSION');

	my $tt = time;
	$rh_SESSION->{"$sid"}->{'LOGIN_TIME'} = $tt;
	$rh_SESSION->{"$sid"}->{'LAST_ACCESS'} = $tt;
	$rh_SESSION->{"$sid"}->{'IP'} = $ip;
	$rh_SESSION->{"$sid"}->{'UID'} = $uid;

	$session_db->SetHash ('SESSION', $rh_SESSION);
	$session_db->Store ();

	## system db --
	my $sys_db = &HashDB::Retrieve ("$system_db_name");
	my $rh_SEC = $sys_db->GetHash ('SYS_SEC_CONFIG');
	my $EXPIRE_MIN = $rh_SEC->{'EXPIRE_MIN'};
	if ($EXPIRE_MIN == 0){$EXPIRE_MIN = '2000';};
	&SetCookie ('ANDSID', $sid, $EXPIRE_MIN);

	return $sid;
}
sub Logout {
	my $sid = &GetCookie ('ANDSID');
        my $ip = $ENV{'REMOTE_HOST'};

	my $session_db = &HashDB::Retrieve ("$session_db_name");
	my $rh_SESSION = $session_db->GetHash ('SESSION');
	my $session_uid = $rh_SESSION->{"$sid"}->{'UID'};
	my $session_ip = $rh_SESSION->{"$sid"}->{'IP'};

	if ($ip eq $session_ip) {
		&SetCookie ('ANDSID', $sid, -100);
		delete ($rh_SESSION->{"$sid"});

		$session_db->SetHash ('SESSION', $rh_SESSION);
		$session_db->Store ();

		return $session_uid;
	}
	return 0;  ## no login user !
}
sub Auth {
	## session db --
	my $session_db = &HashDB::Retrieve ("$session_db_name");
	my $rh_SESSION = $session_db->GetHash ('SESSION');

	## system db --
	my $sys_db = &HashDB::Retrieve ("$system_db_name");
	my $rh_SEC = $sys_db->GetHash ('SYS_SEC_CONFIG');
	my $EXPIRE_MIN = $rh_SEC->{'EXPIRE_MIN'};
	if ($EXPIRE_MIN == 0){$EXPIRE_MIN = '2000';};
	my $tt = time;

	## refresh session --
	my @sessions = keys (%{$rh_SESSION});
	foreach (@sessions) {
		$last_access = $rh_SESSION->{"$_"}->{'LAST_ACCESS'};
		if ($last_access + $EXPIRE_MIN  * 60 < $tt) {
			delete ($rh_SESSION->{"$_"});
		}
	}

	## authentication --
	my $sid = &GetCookie ('ANDSID');
        my $ip = $ENV{'REMOTE_HOST'};

	my $session_uid = $rh_SESSION->{"$sid"}->{'UID'};
	my $session_ip = $rh_SESSION->{"$sid"}->{'IP'};

	if ($ip eq $session_ip) {

		&SetCookie ('ANDSID', $sid, $EXPIRE_MIN);

		## update session --
		$rh_SESSION->{"$sid"}->{'LAST_ACCESS'} = $tt;

		$session_db->SetHash ('SESSION', $rh_SESSION);
		$session_db->Store ();

		return $session_uid;
	}
	print "Content-type: text/html\n\n";
	&parse_template("$denied_file", *STDOUT);
	return 0;  ## auth failer !
}

## password operation -----
sub CheckUserPasswd {
	my ($uid, $pass) = @_;

	my $user_db = &HashDB::Retrieve ("$user_db_name");
	my $rh_USER = $user_db->GetHash ('USER');
	if (!defined ($rh_USER->{"$uid"})) { return 0; }  ## No such user !

	my $crypted_pass = $rh_USER->{"$uid"}->{'PASSWD'};

	if ($crypted_pass) { $pass = crypt ($pass, substr ($crypted_pass, 0, 2)); }
	else { $pass = ""; }

	if ($pass eq $crypted_pass) { return 1; }  ## checking passwd OK !

	return 0;  ## No match !
}
sub ChangeUserPasswd {
	my ($uid, $pass) = @_;

	my $user_db = &HashDB::Retrieve ("$user_db_name");
	my $rh_USER = $user_db->GetHash ('USER');

#	if ($pass ne "") { $pass = crypt ($pass, &Salt); }
	$pass = crypt ($pass, &Salt);
	$rh_USER->{"$uid"}->{'PASSWD'} = $pass;

	$user_db->SetHash ('USER', $rh_USER);
	$user_db->Store ();
}

## cookie -----
sub SetCookie {
	my ($cookie, $value, $EXPIRE_MIN) = @_;
	my $tt = time + $EXPIRE_MIN * 60;
	
	$tt = &time_format ('COOKIE_STYLE', $tt);
        print "Set-Cookie: $cookie=$value; expires=$tt\n";
}
sub GetCookie {
	my ($cookie) = @_;
	my (@pairs, $key, $value, %out);
	@pairs = split (/;\s/, $ENV{'HTTP_COOKIE'});
	foreach (@pairs) {
		($key,$value) = split (/=/, $_);
		if ($key eq $cookie) { return $value; }
	}
}

## others ----
sub Salt {
	my @chr = qw (a b c d e f g h i j k l m n o p q r s t u v w x y z
		      A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
		      0 1 2 3 4 5 6 7 8 9 . /);
	my $s1 = int (rand 63); my $s2 = int (rand 63);
	return "$chr[$s1]$chr[$s2]";
}

sub CreateSessionId {

        # Seed the random generator
        srand($$|time);
        my $session = int(rand(60000));

        # pack the time, process id, and random $session into a
        # hex number which will make up the session id.

        $session = unpack("H*", pack("Nnn", time, $$, $session));

}
sub time_format {
	my ($form, $time) = @_;
	##    $form = 'SYSLOG_STYLE':  Sep  7 01:42:20
	##            'COOKIE_STYLE':  Fri, 31-Dec-1999 23:59:59 GMT

	if ($form eq 'SYSLOG_STYLE') {	
	        my ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
	        $year += 1900;
	        if ($sec  < 10)  { $sec  = "0$sec"; }
	        if ($min  < 10)  { $min  = "0$min"; }
	        if ($hour < 10)  { $hour = "0$hour"; }
	        if ($mday < 10)  { $mday = " $mday"; }

	        $mon = ('Jan','Feb','Mar','Apr','May',
			'Jun','Jul','Aug','Sep','Oct', 'Nov','Dec') [$mon];
	        $wday = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat') [$wday];

		return "$mon $mday $hour:$min:$sec";
	}
	if ($form eq 'COOKIE_STYLE') {
                my ($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime($time);
                $year += 1900;
                if ($sec  < 10)  { $sec  = "0$sec"; }
                if ($min  < 10)  { $min  = "0$min"; }
                if ($hour < 10)  { $hour = "0$hour"; }
                if ($mday < 10)  { $mday = "0$mday"; }

                $mon = ('Jan','Feb','Mar','Apr','May',
			'Jun','Jul','Aug','Sep','Oct', 'Nov','Dec') [$mon];
	        $wday = ('Sunday','Monday','Tuesday',
			'Wednesday','Thursday','Friday','Saturday') [$wday];

                return "$wday, $mday\-$mon\-$year $hour:$min:$sec GMT";
	}
}
sub show_imode_login_denied {
	my $out_line = <<"EOM";
<HTML>
<HEAD>
<TITLE>桼ǧڤ˼Ԥޤ</TITLE>
</HEAD>
<BODY>
桼ǧڤ˼Ԥޤ⤦٥̤ľƤ
<BR><BR>
<CENTER>
<A HREF="login.cgi" accesskey=\"0\">[]</A>
</CENTER>
</BODY>
</HTML>
EOM

	my $input_code = &jcode::convert (\$out_line, $OUTPUT_CODE);

	print "Content-type: text/html\n\n";
	print $out_line;

	exit;
}	
1; #return true 
