#!/usr/bin/perl
#
#  GruopCGI2000
#    bk.pl ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
$my_name = "bk.pl";

$bkdata_dir = './data/bkdata';

@MONTHDAYS = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
($SEC, $MIN, $HOUR, $TODAY, $THIS_MONTH, $THIS_YEAR, $THIS_WDAY) = localtime(time);
if ($THIS_YEAR < 99) { $THIS_YEAR += 2000; } else { $THIS_YEAR += 1900; }
$THIS_MONTH ++;

sub CreateBkfile {
	my ($bk, $year, $month, $day) = @_;
	if ($month < 10) { $month_pad = "0$month"; } else { $month_pad = $month; }
	if ($day < 10) { $day_pad = "0$day"; } else { $day_pad = $day; }
	my $file = "$bkdata_dir/bk$bk/bk$year$month_pad$day_pad";
	
        if (!(-e "$bkdata_dir/bk$bk")) {
                mkdir ("$bkdata_dir/bk$bk", 0777)
                 || &Error::Error::error ("$my_name\:\:CreateBkFile","Can't make dir $bkdata_dir/bk$bk");
        }

        open (BK, ">$file")
		|| &Error::error ("$my_name\:\:CreateBkfile","Can't open $file");
	print BK "\n";
        close (BK);
}
	
sub GetBk {
	my ($bk, $year, $month, $day) = @_;
	my @monthdays = @MONTHDAYS;
	if (($year % 4 == 0 && $year % 100 != 0) || $year % 400 == 0) { $monthdays[1] = 29; }
	if ($month > 12 || $day > $monthdays[$month - 1]) {
		$month = $THIS_MONTH;
		$day = $TODAY;
	}
	if ($month < 10) { $month_pad = "0$month"; } else { $month_pad = $month; }
	if ($day < 10) { $day_pad = "0$day"; } else { $day_pad = $day; }
	my $file = "$bkdata_dir/bk$bk/bk$year$month_pad$day_pad";

        if (!(-e "$file")) { &CreateBkfile ($bk, $year, $month, $day); }

        open (BK, "$file") || &Error::error ("$my_name\:\:GetBk","Can't open $file");
        my @line = <BK>;
        close (BK);

	return @line;
}
sub AddBkInc {
        my ($bk, $year, $month, $day, $room, $value) = @_;
	if ($month < 10) { $month_pad = "0$month"; } else { $month_pad = $month; }
	if ($day < 10) { $day_pad = "0$day"; } else { $day_pad = $day; }
	my $file = "$bkdata_dir/bk$bk/bk$year$month_pad$day_pad";

        if (!(-e "$file")) { return 0; } ## No such file!!

        open (BK, "$file") || &Error::error ("$my_name\:\:AddBkInc","Can't open $file");
        my @line = <BK>;
        close (BK);

	while (@line < $room) { push (@line, "\n"); }

	my ($int1, $int2, $ind1, $ind2, $ind3, $inuid) = split (/\|/, $value);
	$int1 = &TimeToMin ($int1);
	$int2 = &TimeToMin ($int2);

        my $r = 1;
        foreach (@line) {
                if ($room == $r) {
                        chomp;
                        my @col = split (/\t/);
			my $c = 0;
			foreach (@col) {
				my ($t1, $t2, $d1, $d2, $d3, $uid) = split (/\|/);
				$t1 = &TimeToMin ($t1);
				$t2 = &TimeToMin ($t2);
				if ($int2 <= $t1) { last; }
				elsif ($int1 >= $t2) { $c ++; next; }
				else { return 0; }  ## time is conflict !
			}
                        splice (@col, $c, 0, $value);
                        $_ = join ("\t", @col);
                        $_ = "$_\n";
                }
                $r ++;
        }

        open (BK, ">$file") || &Error::error ("$my_name\:\:AddBkIns","Can't open $file");
	flock (BK, 2);
	seek (BK, 0, 2);
        print BK @line;
	flock (BK, 8);
        close (BK);
}
sub UpdateBkInc {
        my ($bk, $year, $month, $day, $room, $inc, $value) = @_;
	if ($month < 10) { $month_pad = "0$month"; } else { $month_pad = $month; }
	if ($day < 10) { $day_pad = "0$day"; } else { $day_pad = $day; }
	my $file = "$bkdata_dir/bk$bk/bk$year$month_pad$day_pad";

        if (!(-e "$file")) { return 0; } ## No such file!!

        open (BK, "$file")
                || &Error::error ("$my_name\:\:AddBkInc","Can't open $file");
        my @line = <BK>;
        close (BK);

        my $r = 1;
        foreach (@line) {
                if ($room == $r) {
                        chomp;
                        my @col = split (/\t/);
			my $col_num = @col;
			if ($inc > $col_num || !$inc) { return 0; } ## $inc is incorrect!!
                        splice (@col, $inc - 1, 1, $value);
                        $_ = join ("\t", @col);
                        $_ = "$_\n";
                }
                $r ++;
        }

        open (BK, ">$file") || &Error::error ("$my_name\:\:AddBkIns","Can't open $file");
	flock (BK, 2);
	seek (BK, 0, 2);
        print BK @line;
	flock (BK, 8);
        close (BK);
}
sub RmBkInc {
        my ($bk, $year, $month, $day, $room, $inc) = @_;
	if ($month < 10) { $month_pad = "0$month"; } else { $month_pad = $month; }
	if ($day < 10) { $day_pad = "0$day"; } else { $day_pad = $day; }
	my $file = "$bkdata_dir/bk$bk/bk$year$month_pad$day_pad";

        if (!(-e "$file")) { return 0; } ## No such file!!

        open (BK, "$file")
                || &Error::error ("$my_name\:\:RmBkInc","Can't open $file");
        my @line = <BK>;
        close (BK);

        my $r = 1;
        foreach (@line) {
                if ($room == $r) {
                        chomp;
                        my @col = split (/\t/);
			my $col_num = @col;
			if ($inc > $col_num || !$inc) { return 0; } ## $inc is incorrect!!
                        splice (@col, $inc - 1, 1);
                        $_ = join ("\t", @col);
                        $_ = "$_\n";
                }
                $r ++;
        }

        open (BK, ">$file") || &Error::error ("$my_name\:\:RmBkIns","Can't open $file");
	flock (BK, 2);
	seek (BK, 0, 2);
        print BK @line;
	flock (BK, 8);
        close (BK);
}
sub TimeToMin {
        my ($time) = @_;
	if ($time !~ /\d+:\d\d/) { return $time; }
        my ($hour, $min) = split (/\:/, $time);
        return $hour * 60 + $min;
}
sub MinToTime {
        my ($min) = @_;
	if ($min =~ /\d+:\d\d/) { return $min; }
        my $hour = int($min / 60);
        my $min = $min % 60;
        if ($min < 10) { $min = "0$min"; }
        return "$hour\:$min";
}

1; #return true
