#!/usr/bin/perl
#
#  GruopCGI2000
#    datecalc.pl ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
my $my_name = "datecalc.pl";

$SUN_LAST = 1;

@MONTHDAYS = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
@YOBI = ("", "", "", "", "", "", "");

($SEC, $MIN, $HOUR, $TODAY, $THIS_MONTH, $THIS_YEAR, $THIS_WDAY) = localtime(time);
if ($THIS_YEAR < 99) { $THIS_YEAR += 2000; } else { $THIS_YEAR += 1900; }
$THIS_MONTH ++;
if (($THIS_YEAR % 4 == 0 && $THIS_YEAR % 100 != 0) || $THIS_YEAR % 400 == 0
	&& THIS_MONTH == 2) { $THIS_MONTHDAYS = 29; } else { $THIS_MONTHDAYS = $MONTHDAYS[$THIS_MONTH - 1]; }
if ($MIN <10) { $TIME = "$HOUR:0$MIN"; } else { $TIME = "$HOUR:$MIN"; }

sub ThisWeekDate {

	my $yweek = &GetYweek ($THIS_YEAR, $THIS_MONTH, $TODAY);
	my @ret = &WeekDate ($THIS_YEAR, $yweek);
	return @ret;	
}
sub ThisMonthWday {
	my (@wdays, $i);
	my $swday = &GetWday ($THIS_YEAR, $THIS_MONTH, 1);

	my @monthdays = @MONTHDAYS;
	if ((($year % 4 == 0) && ($year % 100 != 0)) || ($year % 400 == 0)) { $monthdays[1] = 29; }

	for ($i=0; $i < $monthdays[$THIS_MONTH - 1]; $i ++) {
		$wdays[$i] = $swday % 7;
		$swday ++;
	}
	return @wdays;
}
sub WeekDate {
	my ($year, $yweek) = @_;
	my (@ret);

	my @monthdays = @MONTHDAYS;
	if ((($year % 4 == 0) && ($year % 100 != 0)) || ($year % 400 == 0)) { $monthdays[1] = 29; }

	my $eyweek = &GetYweek ($year, 12, 31);
	if ($yweek > $eyweek) { $year ++; $yweek = $yweek - $eyweek + 1; }

	my $swday = &GetWday ($year, 1, 1);
	if ($SUN_LAST) { if ($swday == 0) { $swday = 6; } else { $swday --; } }

	my ($sday, $m);
	if ($yweek == 1) {
		if ($swday == 0) { $m = 0; $sday = 1 } else { $m = 11; $sday = 31 - $swday + 1; }

	} else {
		$sday = ($yweek - 1) * 7 - $swday + 1;
		$m = 0;
		while ($sday > $monthdays[$m]) {
			$sday -= $monthdays[$m];
			$m ++;
		}
	}

	for ($i = 0; $i < 7; $i ++) {
		if ($sday > $monthdays[$m]) {
			if ($m >= 11) { $m = 0; } else { $m ++; }
			$sday = 1;
		}
		my $month = $m + 1;
		push (@ret, "$month/$sday");
		$sday ++;
	}

	return @ret;
}
sub MonthWday {
	my ($year, $month) = @_;

	my @monthdays = @MONTHDAYS;
	if ((($year % 4 == 0) && ($year % 100 != 0)) || ($year % 400 == 0)) { $monthdays[1] = 29; }

	my (@wdays);
	my $swday = &GetWday ($year, $month, 1);
	for (my $i=0; $i < $monthdays[$month -1]; $i ++) {
		$wdays[$i] = $swday % 7;
		$swday ++;
	}
	return @wdays;
}
sub GetWday {
	my ($year, $month, $day) = @_;
	if ($month < 3) {
		$year --;
		$month += 12;
	}
	my $wday = ($year + int($year/4) - int($year/100) + int($year/400)
					+ int((13 * $month + 8)/5) + $day) % 7;
	return $wday;
}
sub GetYweek {
	my ($year, $month, $day) = @_;
	my $yday = &GetYday ($year, $month, $day);
	my $swday = &GetWday ($year, 1, 1);
	if ($SUN_LAST) {
		if ($swday == 0) { $swday = 6; } else { $swday --; }
	}
	my $yweek = int(($swday + $yday - 0.1) / 7) + 1;
	return $yweek;
}
sub GetYday {
	my ($year, $month, $day) = @_;
	my @monthdays = @MONTHDAYS;
	my ($yday, $i);
	if ((($year % 4 == 0) && ($year % 100 != 0)) || ($year % 400 == 0)) {
		$monthdays[1] = 29;
	}
	for ($i=0; $i < $month - 1; $i ++) {
		$yday += $monthdays[$i];
	}
	$yday += $day;
	return $yday;
}
sub TimeToMin {
        my ($time) = @_;
	if ($time !~ /^[0-2]?[0-9]\:[0-5][0-9]$/) { return $time; }
        my ($hour, $min) = split (/\:/, $time);
        return $hour * 60 + $min;
}
sub MinToTime {
        my ($min) = @_;
	if ($min !~ /^\d+$/) { return $min; }
	if ($min > 24 * 60) { $min -= 24 * 60; }
        my $hour = int($min / 60);
        my $min = $min % 60;
        if ($min < 10) { $min = "0$min"; }
        return "$hour\:$min";
}
1; ## return true
