#!/usr/bin/perl
#
#  GruopCGI2000
#    hashdb.pl ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
my $my_name = 'hashdb.pl';  ## This script name
my $db_dir = './data';
my $CGI = 1;  ## for CGI use

package HashDB;

sub Retrieve {
	my $db_name = shift;
	my $db_file = "$db_dir/$db_name.hdb";

	open (DB, "$db_file") || &Error::error ("$my_name\:\:Retrieve","Can't open $db_file");
	my @data_line = <DB>;
	close (DB);
	unshift (@data_line, "$db_name");
	my $ra_data_line = \@data_line;

	bless ($ra_data_line, 'HashDB');

	return $ra_data_line;
}
sub GetHash {
	my ($hdb, $hash_name) = @_;

	## separating data stream from DB. ----
	my $flag = 0;
	my @hash_line;
	foreach (@{$hdb}) {
		if (/^[# \r\n]/) { next; }
		if (/^$hash_name\W/) { $flag = 1; }
		if ($flag) { push (@hash_line, $_); }
		if (/}/ && $flag) { last; }
	}
#	print "@hash_line\n";  ## debug print ! 

	## constracting data stracture. ----
	my $rh_result;
	my @keys;
	foreach (@hash_line) {
		chomp;
		if (/^$hash_name\W/) { $keys[0] = $hash_name; next; }
		if (/{/) { next; }
		my $n = 0;
		while ($_ =~ s/^\t//) { $n ++; }

		if (/^(\w+)[ \r\n\f]*/) {
			$keys[$n] = "$1";

			## if exist "=>" operator, connecting hive refference. ----
			if (/^(\w+) ?=> ?(\w+)/) {
				my ($key, $value) = ($1, $2);
				$keys[$n] = "$key";

				my $r_hive_temp = &GetHash ($hdb, $value);
			#	print "$n, @keys, $value\n";  ## debug print !

				my $str = "";
				while (defined ($key = $keys[$n])) {
					$str = "\-\>\{$key\}$str";
					if ($n == 1) { last; }
					$n--;
				}
				eval "\$rh_result$str = \$r_hive_temp\n";
			#	print "\$rh_result$str = \$r_hive_temp\n";  ## debug print !

			## if exist "=" operator, substituting value for refference key. ----
			} elsif (/^(\w+) ?= ?(['"]?)(.*)\2/) {
				my ($key, $value) = ($1, $3);
				$keys[$n] = "$key";
			#	print "$n, @keys, $value\n";  ## debug print !

				my $str = "";
				while (defined ($key = $keys[$n])) {
					$str = "\-\>\{\'$key\'\}$str";
					if ($n == 1) { last; }
					$n--;
				}
				eval "\$rh_result$str = \'$value\'\n";
			#	print "\$rh_result$str = \'$value\'\n";  ## debug print !
			}
		}
		if (/}/) { last; }
	}

	return $rh_result;
}
sub Store {
	my ($hdb) = @_;
	my $db_name = shift (@{$hdb});
	my $db_file = "$db_dir/$db_name.hdb";

	open (DB, ">$db_file") || &Error::error ("$my_name\:\:Store","Can't open $db_file");
	flock (DB, 2);
	seek (DB, 0, 2);
	print DB @{$hdb};
	flock (DB, 8);
	close (DB);
}
sub SetHash {
	my ($hdb, $hash_name, $rh_hash) = @_;

	## make hash data stream Dump ----
	my @line = ("");
	my $ra_dump = \@line;
	&DumpLoop ("$hash_name {", 0, $rh_hash, $ra_dump);
	push (@line, "}\n");

	## seek data stream from DB. ----
	my $flag = 0;
	my $r = 0;
	my ($r_s, $r_e) = (0, 0);
	foreach (@{$hdb}) {
		$r ++;
		if (/^[# \r\n]/) { next; }
		if (/^$hash_name\W/) { $flag = 1; $r_s = $r; next; }
		if (/}/ && $flag) { $r_e = $r; last; }
	}
	## set data stream dump. ----
	if ($flag) { splice (@{$hdb}, $r_s - 1, $r_e - $r_s + 1, @line); }
	else { push (@{$hdb}, @line); }

#	print "@{$hdb}";  ## debug print !
}
sub DumpLoop{
	my ($key, $level,  $r_hash, $r_result) = @_;
	my $tabs = "";
	my $n = 0;
	while ($n < $level) { $tabs = "$tabs\t"; $n ++; }
	push(@{$r_result}, "$tabs$key\n");
	my @keys = keys (%{$r_hash});
	foreach (@keys) {
		my $r_temp = $r_hash->{"$_"};
		if (ref ($r_temp)) {
			&DumpLoop ($_, $level + 1, $r_temp, $r_result);
		} else {
			push (@{$r_result}, "$tabs\t$_ = \'$r_temp\'\n");
		}
	}
}
sub RemoveHash {
	my ($hdb, $hash_name) = @_;

	## seek data stream from DB. ----
	my $flag = 0;
	my $r = 0;
	my ($r_s, $r_e) = (0, 0);
	foreach (@{$hdb}) {
		$r ++;
		if (/^[# \r\n]/) { next; }
		if (/^$hash_name\W/) { $flag = 1; $r_s = $r; next; }
		if (/}/ && $flag) { $r_e = $r; last; }
	}
	## set data stream dump. ----
	if ($flag) { splice (@{$hdb}, $r_s - 1, $r_e - $r_s + 1); }
	else { return 0; }

#	print "@{$hdb}";  ## debug print !
}

package Error;
##  error ------
sub error {
	my @msg = @_;

	if (!@msg) { @msg = ("Error: script encountered fatal error\n"); }

	if ($CGI) {
		print "Content-type: text/html\n";
		print "Pragma: no-cache\n";
		print "Cache-Control: no-cache\n\n";
	        print "<html>\n<body bgcolor=#FFFFFF>\n";
	        print "<center><hr width=75%><h3>ERROR !</h3>\n";
		foreach (@msg) {
		        print "<P><font color=#DD0000><B>$_</B></font>\n";
		} print "<P><hr width=75%></center>\n"; } else {
		print "auth-lib.pl: @msg";
	}
        exit;
}

1; #return true 
