#!/usr/bin/perl
#
#  GruopCGI2000
#    ktsheet.pl ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
my $my_name = "ktsheet.pl";

my $ktdata_dir = './data';
my $ktlock_dir = './data';

require "datecalc.pl";

sub TransDate {
	my ($year, $month, $day, $time) = @_;
	my $dayd;
	my $date_line = &TimeToMin ($DATE_LINE);
	if ($date_line >= 24 * 60) { $date_line -= 24 * 60; }
	if ($date_line <= &TimeToMin ($time)) { $dayd = $day; }
        else { $dayd = $day - 1; }
        if ($dayd < 1 ) {
		$month --;
		if ($month < 1) { $month = 12; $year --; }
		if (($year % 4 == 0 && $year % 100 != 0)
	 		|| $year % 400 == 0) { $MONTHDAYS[1] = 29; }
		 $dayd = $MONTHDAYS[$month - 1];
	}
	my $mond;
        if ($SHIME eq "MATU") { $mond = $month; }
        elsif ($SHIME < $dayd) { $mond = $month; }
        else { $mond = $month - 1; }
        if ($mond < 1 ) { $mond = 12; $year --; }

	my $yeard;
	if ($SHIME_MON < $mond) { $yeard = $year; }
	else { $yeard = $year - 1; }

	return ($yeard, $mond, $dayd);
}
sub GetKtsheet {
        my ($uid, $year, $mond) = @_;
	if ($mond < 10) { $mond_pad = "0$mond"; } else { $mond_pad = $mond; }
	my $file = "$ktdata_dir/$uid/kt$year$mond_pad";

#	if ($SHIME eq "MATU") {
#		($year_s, $month_s, $day_s) = ($year, $mond, 1);
#		($year_e, $month_e, $day_e) = ($year, $mond, $monthdays[$mond - 1]);
#	} else {
#		($year_s, $month_s, $day_s) = ($year, $mond, $SHIME + 1);
#		($year_e, $month_e, $day_e) = ($year, $mond + 1, $SHIME);
#	}
        if (!(-e "$file")) { return 0; }  ## No ktsheet file.

        open (KT, "$file") || &Error::error ("$my_name\:\:GetKtsheet","Can't open $file");
        my @line = <KT>;
        close (KT);

        return @line;
}
sub CreateKtsheet {

        my ($uid, $year, $mond) = @_;
	if ($mond < 10) { $mond_pad = "0$mond"; } else { $mond_pad = $mond; }
	my $file = "$ktdata_dir/$uid/kt$year$mond_pad";

	my @monthdays = (31,28,31,30,31,30,31,31,30,31,30,31);
        if ((($year % 4 == 0) && ($year % 100 != 0)) || ($year % 400 == 0)) { $monthdays[1] = 29; }

	my (@date, $wday);
	if ($SHIME eq "MATU") {
		@date = (1 .. $monthdays[$mond - 1]);
		$wday = &GetWday ($year, $mond, 1);
	} else {
		@date = ($SHIME + 1 .. $monthdays[$mond - 1], 1 .. $SHIME);
		$wday = &GetWday ($year, $mond, $SHIME + 1);
	}
	foreach (@date) {
		chomp;
		$wday = $wday % 7;
		$_ = "$_\t$wday\n";
		$wday ++;
	}	
	push (@date, "CHOSEI\n", "SYUKEI\n");

        open (KT, ">$file") || &Error::error ("$my_name\:\:CreateKtsheet","Can't open $file");
        print KT @date;
        close (KT);
}
sub GetKt {
        my ($uid, $year, $mond, $day) = @_;
	if ($mond < 10) { $mond_pad = "0$mond"; } else { $mond_pad = $mond; }
	my $file = "$ktdata_dir/$uid/kt$year$mond_pad";

        if (!(-e "$file")) { return 0; } ## No such file!!

        open (KT, "$file") || &Error::error ("$my_name\:\:GetKt","Can't open $file");
        my @line = <KT>;
        close (KT);

        foreach (@line) {
                chomp;
                my @col = split (/\t/);
                if ($col[0] eq $day) {
                        return @col;
                }
	}
	return 0; ## No such
}
sub UpdateKt {
        my ($uid, $year, $mond, $day, $value) = @_;
	if ($mond < 10) { $mond_pad = "0$mond"; } else { $mond_pad = $mond; }
	my $file = "$ktdata_dir/$uid/kt$year$mond_pad";

        if (!(-e "$file")) { return 0; } ## No such file!!

        open (KT, "$file") || &Error::error ("$my_name\:\:UpdateKt","Can't open $file");
        my @line = <KT>;
        close (KT);

        foreach (@line) {
                chomp;
                my @col = split (/\t/);
                if ($day eq $col[0]) { $_ = "$value\n"; last; }
		$_ = "$_\n";
        }
	my @syukei;
	$syukei[0] = "SYUKEI";
	pop (@line);
	foreach (@line) {
		chomp;
		my @col = split (/\t/);
		if ($col[2] ne "" || $col[3] ne"") { $syukei[1] ++; }
		for (my $i = 4; $i <= 15; $i ++) {
			if ($col[$i] eq "1") { my $n = $i - 2; $syukei[$n] ++; }
		}
		for (my $i = 16; $i <= 21; $i ++) {
			if ($col[$i]) { my $n = $i - 2; $syukei[$n] += $col[$i]; }
		}
		if ($col[24] eq "1") { $syukei[20] ++; }
		$_ = "$_\n";
	}
	my $syu = join ("\t", @syukei);
	push (@line, "$syu\n");

        open (KT, ">$file") || &Error::error ("$my_name\:\:UpdateKt","Can't open $file");
	flock (KT, 2);
	seek (KT, 0, 2);
        print KT @line;
	flock (KT, 8);
        close (KT);
}
sub Syukkin {
        my ($uid, $year, $mond, $dayd, $time) = @_;
	if ($mond < 10) { $mond_pad = "0$mond"; } else { $mond_pad = $mond; }
	my $file = "$ktdata_dir/$uid/kt$year$mond_pad";

        if (!(-e "$file")) { &CreateKtsheet ($uid, $year, $mond); }

        my @col = &GetKt ($uid, $year, $mond, $dayd);
	if ($col[2] eq "") {
		$col[2] = $time;
		if ($col[16] eq "") { $col[16] = $KYUKEI; }
		if ($col[17] eq "") { $col[17] = $SYURO; }
		if ($col[22] eq "") { $col[22] = $DEF_SYUKKIN; }
		if ($col[23] eq "") { $col[23] = $DEF_TAIKIN; }
		$value = join ("\t", @col);
        	&UpdateKt ($uid, $year, $mond, $dayd, $value);
	}
}
sub Taikin {
        my ($uid, $year, $mond, $dayd, $time) = @_;
	if ($mond < 10) { $mond_pad = "0$mond"; } else { $mond_pad = $mond; }
	my $file = "$ktdata_dir/$uid/kt$year$mond_pad";

        if (!(-e "$file")) { &CreateKtsheet ($uid, $year, $mond); } ## It's NO good!

        my @col = &GetKt ($uid, $year, $mond, $dayd);
	if ($col[3] eq "") {
		$col[3] = $time;
		if ($col[16] eq "") { $col[16] = $KYUKEI; }
		if ($col[17] eq "") { $col[17] = $SYURO; }
		if ($col[22] eq "") { $col[22] = $DEF_SYUKKIN; }
		if ($col[23] eq "") { $col[23] = $DEF_TAIKIN; }
		$value = join ("\t", @col);
        	$ret = &UpdateKt ($uid, $year, $mond, $dayd, $value);
	}
}
sub LockKtsheet {
        my ($uid, $year, $mond) = @_;
	my $file = "$ktlock_dir/$uid/ktLOCK";

	my @line;
	if (-e "$file") {
        	open (LOCK, "$file") || &Error::error ("$my_name\:\:LockKtsheet","Can't open $file");
        	@line = <LOCK>;
        	close (LOCK);
	}
	my $flag = 0;
	foreach (@line) {
		if (/^#|^\s+/) { next; }
		my $temp = $_;
		chomp ($temp);
		if ($temp eq "$year$mond") { $flag = 1; last; }
	}
	if (!$flag) { push (@line, "$year$mond\n"); }

        open (LOCK, ">$file") || &Error::error ("$my_name\:\:LockKtsheet","Can't open $file");
	flock (LOCK, 2);
	seek (LOCK, 0, 2);
        print LOCK @line;
	flock (LOCK, 8);
        close (LOCK);
}
sub CheckLockKtsheet {
        my ($uid, $year, $mond) = @_;
	my $file = "$ktlock_dir/$uid/ktLOCK";

	my @line;
	if (-e "$file") {
        	open (LOCK, "$file") || &Error::error ("$my_name\:\:LockKtsheet","Can't open $file");
        	@line = <LOCK>;
        	close (LOCK);
	}
	my $flag = 0;
	foreach (@line) {
		if (/^#|^\s+/) { next; }
		my $temp = $_;
		chomp ($temp);
		if ($temp eq "$year$mond") { return 1; }  ## It's locked.
	}
	return 0;  ## It's not locked.
}
1; ## reutrn true
