#!/usr/bin/perl
#
#  GruopCGI2000
#    sched.pl ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
my $my_name = "sched.pl";

my $scdata_dir = './data';
require "datecalc.pl";

sub CreateSched {
	my ($uid, $year, $yweek) = @_;
	if ($yweek < 10) { $yweek_pad = "0$yweek"; } else { $yweek_pad = $yweek; }
	my $file = "$scdata_dir/$uid/sc$year$yweek_pad";
	
	my @date = &WeekDate ($year, $yweek);

        open (SC, ">$file") || &Error::error ("$my_name\:\:CreateSched","Can't open $file");
	foreach (@date) { print SC "$_\n"; }
        close (SC);
}
	
sub GetSched {
	my ($uid, $year, $yweek) = @_;

	my $eyweek = &GetYweek ($year, 12, 31);
	if ($yweek > $eyweek) { $year ++; $yweek = $yweek - $eyweek + 1; }

	if ($yweek < 10) { $yweek_pad = "0$yweek"; } else { $yweek_pad = $yweek; }
	my $file = "$scdata_dir/$uid/sc$year$yweek_pad";
        if (!(-e "$file")) { &CreateSched ($uid, $year, $yweek); }

        open (SC, "$file") || &Error::error ("$my_name\:\:GetSched","Can't open $file");
        my @line = <SC>;
        close (SC);

	return @line;
}
sub UpdateSched {
        my ($uid, $year, $yweek, $wday, $ins, $value) = @_;

	my $eyweek = &GetYweek ($year, 12, 31);
	if ($yweek >= $eyweek) { $year ++; $yweek = $yweek - $eyweek + 1; }

	if ($yweek < 10) { $yweek_pad = "0$yweek"; } else { $yweek_pad = $yweek; }
	my $file = "$scdata_dir/$uid/sc$year$yweek_pad";
        if (!(-e "$file")) { return 0; } ## No such file!!

        open (SC, "$file") || &Error::error ("$my_name\:\:UpdateSched","Can't open $file");
        my @line = <SC>;
        close (SC);

        my $r = 1;
        foreach (@line) {
                if ($wday eq $r) {
                        chomp;
                        @col = split (/\t/);
			while (@col < $ins + 1) { push (@col, ""); }
                        $col[$ins] = $value;
                        $_ = join ("\t", @col);
                        $_ = "$_\n";
                }
                $r ++;
        }
        open (SC, ">$file") || &Error::error ("$my_name\:\:UpdateWb","Can't open $file");
	flock (SC, 2);
	seek (SC, 0, 2);
        print SC @line;
	flock (SC, 8);
        close (SC);
}
sub GetIns {
        my ($uid, $year, $yweek, $wday, $ins) = @_;

	my $eyweek = &GetYweek ($year, 12, 31);
	if ($yweek >= $eyweek) { $year ++; $yweek = $yweek - $eyweek + 1; }

	if ($yweek < 10) { $yweek_pad = "0$yweek"; } else { $yweek_pad = $yweek; }
	my $file = "$scdata_dir/$uid/sc$year$yweek_pad";
        if (!(-e "$file")) { return 0; } ## No such file!!

        open (SC, "$file") || &Error::error ("$my_name\:\:UpdateSched","Can't open $file");
        my @line = <SC>;
        close (SC);

        my $r = 1;
        foreach (@line) {
                if ($wday eq $r) {
                        chomp;
                        @col = split (/\t/);
			return $col[$ins -1];
                }
                $r ++;
        }
	return 0; ## no good !
}
sub RmIns {
        my ($uid, $year, $yweek, $wday, $ins) = @_;

	my $eyweek = &GetYweek ($year, 12, 31);
	if ($yweek >= $eyweek) { $year ++; $yweek = $yweek - $eyweek + 1; }

	if ($yweek < 10) { $yweek_pad = "0$yweek"; } else { $yweek_pad = $yweek; }
	my $file = "$scdata_dir/$uid/sc$year$yweek_pad";
        if (!(-e "$file")) { return 0; } ## No such file!!

        open (SC, "$file") || &Error::error ("$my_name\:\:RmCol","Can't open $file");
        my @line = <SC>;
        close (SC);

        my $r = 1;
        foreach (@line) {
		if ($r == $wday) {
                	chomp;
                	my @col = split (/\t/);
			@temp = splice (@col, $ins);
			shift (@temp);
			push (@col, @temp);
                	$_ = join ("\t", @col);
                	$_ = "$_\n";
		}
                $r ++;
        }

        open (SC, ">$file") || &Error::error ("$my_name\:\:RmCol","Can't open $file");
	flock (SC, 2);
	seek (SC, 0, 2);
        print SC @line;
	flock (SC, 8);
        close (SC);
}
sub AddIns {
        my ($uid, $year, $yweek, $wday, $ins, $value) = @_;

	my $eyweek = &GetYweek ($year, 12, 31);
	if ($yweek >= $eyweek) { $year ++; $yweek = $yweek - $eyweek + 1; }

	if ($yweek < 10) { $yweek_pad = "0$yweek"; } else { $yweek_pad = $yweek; }
	my $file = "$scdata_dir/$uid/sc$year$yweek_pad";
        if (!(-e "$file")) { return 0; } ## No such file!!

        open (SC, "$file") || &Error::error ("$my_name\:\:RmCol","Can't open $file");
        my @line = <SC>;
        close (SC);

        my $r = 1;
        foreach (@line) {
                if ($r == $wday) {
                        chomp;
                        my @col = split (/\t/);
                        while (@col < $ins) { push (@col, "&nbsp;") }
                        @temp = splice (@col, $ins);
                        push (@col, $value, @temp);
                        $_ = join ("\t", @col);
                        $_ = "$_\n";
                }
                $r ++;
        }

        open (SC, ">$file") || &Error::error ("$my_name\:\:RmCol","Can't open $file");
	flock (SC, 2);
	seek (SC, 0, 2);
        print SC @line;
	flock (SC, 8);
        close (SC);
}
sub TimeToMin {
        my ($time) = @_;
	if ($time !~ /^[0-2]?[0-9]\:[0-5][0-9]$/) { return $time; }
        my ($hour, $min) = split (/\:/, $time);
        return $hour * 60 + $min;
}
sub MinToTime {
        my ($min) = @_;
	if ($min !~ /^\d+$/) { return $min; }
	if ($min > 24 * 60) { $min -= 24 * 60; }
        my $hour = int($min / 60);
        my $min = $min % 60;
        if ($min < 10) { $min = "0$min"; }
        return "$hour\:$min";
}

1; #return true
